#include "u8g.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <avr/interrupt.h>
#include <avr/io.h>

u8g_t u8g;
int vieti = 5; 
static char words[4][20] = {"program", "masina", "salut", "smartphone"};
static char *alfabet = {"a", "b", "c", "d", "e", "f", "g", "h", "i", "j", 'k", "l", "m", "n", "o", "p", "q", "r", "s", "t", "u", "v", "w", "x", "y", "z"};
int lungime;
char *secret_word;

void io_init(void)
{
    DDRB &= ~((1 << PB0) | (1 << PB1) | (1 << PB2));
    PORTB |=  (1 << PB0) | (1 << PB1) | (1 << PB2);
    
    DDRC &= ~(1 << PC0);
    PORTC |= (1 << PC0);
    
    PCICR |= (1 << PCIE0) | (1 << PCIE2);
    PCMSK0 |= (1 << PCINT4) | (1 << PCINT5) | (1 << PCINT6) | (1 << PCINT7);
    PCMSK2 |= (1 << PCINT16);
}


void print(void)
{    
    u8g_SetDefaultForegroundColor(&u8g);
    u8g_SetFont(&u8g, u8g_font_helvB10);
    u8g_DrawStr(&u8g, 5, 25, "Guess the word");
	u8g_DrawStr(&u8g, 30, 37, "5 vieti");
	lungime = sizeof(words[0]);
	secret_word = (char*)malloc(lungime*sizeof(char));
	int i;
	for(i = 0; i < lungime; i++)
		secrect_word[i] = '_';
    u8g_DrawStr(&u8g, 40, 40 + lungime, secret_word);
	u8g_DreawStr(&u8g, 60, 86, alfabet);
}

int pick_letter_to guess(int *count) {
	while((PINB & (1 << PB1)) != 0) {
		if ((PINB & (1 << PB0)) == 0) {
			if (*count > 0)
				*count --;
		}
		if ((PINB & (1 << PB2)) == 0) {
			if (*count < lungime)
				*count ++;
		}
	}

	if ((PINB & (1 << PB1)) == 0) {
		int x = guess_letter(count);
	}

	return x;
}

int guess_letter(int letter_number) {
	int count = 0;
	while (1) {
		if ((PINB & (1 << PB1)) == 0) {
			if (words[0][letter_number] == alfabet[count])
				return letter_number;
			else {
				vieti--;
				if (vieti == 0)
					return -1;
			}
		}
		if ((PINB & (1 << PB0) == 0) {
			if (count > 0)
				count++;
		}
		if ((PINB & (1 << PB2) == 0) {
			if (count < 25)
				count--;
		}
	}

}

int main(void)
{
    io_init();
	int count = 0;
	int victory = 1;
	int letter_number = 0;
    for ( ; ; )
    {        
        u8g_FirstPage(&u8g);
        do
        {	
			victory = 1;
            print();
			int ret = pick_letter_to_guess(count);
			if (ret == -1) {
				u8g_DreawStr(&u8g, 90, 102, "Ai pierdut!");
				return 0;
			}
			else
				secret_word[ret] = words[0][ret];
			for (i = 0; i < lungime; i++)
				if (secret_word[i] == '_')
					victory = 0;
			if (victory == 1) {
				u8g_DreawStr(&u8g, 110, 121, "Ai castigat!");
				return 0;
			}
        } while (u8g_NextPage(&u8g));    
    }
}

